/*
	Eclipse Projekt Demonstration_SDP_Ampelsteuerung
	Datei Red.cpp
	Exemplarische Beschreibung der Besonderheiten fr alle Ampelphasen
 */

#include "Red.h"

namespace State {

/* --------------------------------------------------------------------- */

Red::Red()
{
}

/* ---------------------------------------------------------------------

	"static" bewirkt, dass die Variable theInstance nur einmalig
	initialisiert wird. Genau genommen beim ersten Aufruf von getInstance().
	Das return liefert also immer die gleiche Variable zurck.
	Daher der Name singleton.
 */

Red* Red::getInstance() {
	static Red theInstance;
	return(&theInstance);
}

/* --------------------------------------------------------------------- */

void Red::display() {
	std::cout << std::endl << "|###|   |   |";
}

/* ---------------------------------------------------------------------

	Hier steckt also die Verkettung der Ampelphasen. Schlimm.
	Preisfrage: wie wrde man es schon in main() anders machen?
 */

void Red::advance(Controller* c) {
	State* newState = YellowFromRed::getInstance();
	c->setState(newState);
}

/* --------------------------------------------------------------------- */

}
