#ifndef STATE_STATE_H
#define STATE_STATE_H

#include "../Timer.h"

class Controller; // forward declaration for pointer below
namespace State {

/* --------------------------------------------------------------------- */

class State
{
	public:
/* Any method, not just virtual ones, can be overridden in subclasses.
   virtual gives you the ability to select at run-time the most-derived
   override of a method.

   The term "pure virtual" refers to virtual functions that need to be
   implemented by a subclass and have not been implemented by the base class.

   You designate a method as pure virtual by using the virtual keyword and
   adding a =0 at the end of the method declaration.
 */
		virtual void display() =0;
		virtual void advance(Controller*) =0;
		void step(Controller*, Timer* t);
		void setDuration(int);
		void setupTimer(Timer*);
	protected:
		int duration;
	private:
};

/* --------------------------------------------------------------------- */

}

#endif // STATE_STATE_H
